//
//  K8055.h
//  K8055Demo
//
//  Created by Peter Henderson on 11/09/05.
//  Copyright 2005 Control Plus. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#include <IOKit/IOKitLib.h>
#include <IOKit/IOMessage.h>
#include <IOKit/IOCFPlugIn.h>
#include <IOKit/usb/IOUSBLib.h>
#include <IOKit/hid/IOHIDLib.h>
#include <IOKit/hid/IOHIDKeys.h>

// Change these two constants to match your device
#define kVellemanVendorID		0x10CF

// velleman K8055
// 0x5500 at address 0
// 0x5501 at address 1
// 0x5502 at address 2
// 0x5503 at address 3

#define kK8055_0_ProductID		0x5500
#define kK8055_1_ProductID		0x5501
#define kK8055_2_ProductID		0x5502
#define kK8055_3_ProductID		0x5503


@interface K8055 : NSObject
{
	int cardAddress;
	BOOL online;
	UInt8 DA1;
	UInt8 DA2;
	UInt8 AD1;
	UInt8 AD2;
	UInt8 inputValue;
	UInt8 outputValue;
	UInt16 counter1;
	UInt16 counter2;
	IOHIDDeviceInterface **k8055Interface;
	
	UInt8 lastDin;
	BOOL outputTest;
}

- (int)cardAddress;
- (void)setCardAddress:(int)newCardAddress;
- (BOOL)online;
- (void)setOnline:(BOOL)newOnline;
- (UInt8)DA1;
- (void)setDA1:(UInt8)newDA1;
- (UInt8)DA2;
- (void)setDA2:(UInt8)newDA2;
- (UInt8)AD1;
- (void)setAD1:(UInt8)newAD1;
- (UInt8)AD2;
- (void)setAD2:(UInt8)newAD2;
- (UInt8)inputValue;
- (void)setInputValue:(UInt8)newInputValue;
- (UInt8)outputValue;
- (void)setOutputValue:(UInt8)newOutputValue;
- (UInt16)counter1;
- (void)setCounter1:(UInt16)newCounter1;
- (UInt16)counter2;
- (void)setCounter2:(UInt16)newCounter2;

- (BOOL)outputTest;
- (void)setOutputTest:(BOOL)newOutputTest;

@end

extern NSString *PRHNewDataFromK8055;

