#import "K8055Controller.h"

@implementation K8055Controller

//--------------------------------------------------------------------------------------

- (void) awakeFromNib
{
	K8055Interface = [[K8055 alloc] init];
	[DA1Slider setIntValue:0];
	[DA1Text setIntValue:0];
	[DA2Slider setIntValue:0];
	[DA2Text setIntValue:0];
	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(newDataFromK8055:) name:PRHNewDataFromK8055 object:nil];
}
//--------------------------------------------------------------------------------------
- (void)newDataFromK8055:(NSNotification *)notification
{
	if(K8055Interface)
	{
		[Input1 setState:[K8055Interface inputValue]&0x01];
		[Input2 setState:[K8055Interface inputValue]&0x02];
		[Input3 setState:[K8055Interface inputValue]&0x04];
		[Input4 setState:[K8055Interface inputValue]&0x08];
		[Input5 setState:[K8055Interface inputValue]&0x10];

		[AD1Slider setValue:(float)[K8055Interface AD1]];
		[AD1Text setIntValue:[K8055Interface AD1]];
		[AD2Slider setValue:(float)[K8055Interface AD2]];
		[AD2Text setIntValue:[K8055Interface AD2]];

	
		[Counter1Text setIntValue:[K8055Interface counter1]];
		[Counter2Text setIntValue:[K8055Interface counter2]];
		
	}
}

//--------------------------------------------------------------------------------------
- (IBAction)ClearAllAnalogAction:(id)sender
{
	[K8055Interface setDA1:0];
	[K8055Interface setDA2:0];
	[DA1Slider setIntValue:0];
	[DA1Text setIntValue:0];
	[DA2Slider setIntValue:0];
	[DA2Text setIntValue:0];
}

//--------------------------------------------------------------------------------------
- (IBAction)ClearAllDigitalAction:(id)sender
{
	[K8055Interface setOutputValue:0];
	[Output1 setState:0];
	[Output2 setState:0];
	[Output3 setState:0];
	[Output4 setState:0];
	[Output5 setState:0];
	[Output6 setState:0];
	[Output7 setState:0];
	[Output8 setState:0];

}

//--------------------------------------------------------------------------------------
- (IBAction)ConnectAction:(id)sender
{
	int address = 0;
	if(![SK5 state])
		address++;
	if(![SK6 state])
		address+=2;
	[K8055Interface setCardAddress:address];
	if([K8055Interface open])
	{
		[InfoText setStringValue:@"Connected OK"];
	}
}

//--------------------------------------------------------------------------------------
- (IBAction)Counter1DebounceAction:(id)sender
{

	int ms = 0;
	switch([sender selectedRow])
	{
		case 0:
			ms = 0;
			break;
		case 1:
			ms = 2;
			break;
		case 2:
			ms = 10;
			break;
		case 3:
			ms = 100;
			break;
	}
	[K8055Interface setDebounceForCounter:1 debounce:ms];
}

//--------------------------------------------------------------------------------------
- (IBAction)Counter1ResetAction:(id)sender
{
	[K8055Interface resetCounter:1];
}

//--------------------------------------------------------------------------------------
- (IBAction)Counter2DebounceAction:(id)sender
{
	int ms = 0;
	switch([sender selectedRow])
	{
		case 0:
			ms = 0;
			break;
		case 1:
			ms = 2;
			break;
		case 2:
			ms = 10;
			break;
		case 3:
			ms = 100;
			break;
	}
	[K8055Interface setDebounceForCounter:2 debounce:ms];
}

//--------------------------------------------------------------------------------------
- (IBAction)Counter2ResetAction:(id)sender
{
	[K8055Interface resetCounter:2];
}

//--------------------------------------------------------------------------------------
- (IBAction)DA1SliderAction:(id)sender
{
	[K8055Interface setDA1:[sender intValue]];
	[DA1Text setIntValue:[sender intValue]];
}

//--------------------------------------------------------------------------------------
- (IBAction)DA2SliderAction:(id)sender
{
	[K8055Interface setDA2:[sender intValue]];
	[DA2Text setIntValue:[sender intValue]];
}

//--------------------------------------------------------------------------------------
- (IBAction)Output1Action:(id)sender
{
	if([sender state])
		[K8055Interface setOutputValue:[K8055Interface outputValue]|0x01]; // set the output
	else
		[K8055Interface setOutputValue:[K8055Interface outputValue]&0xFE]; // clear the output
}

//--------------------------------------------------------------------------------------
- (IBAction)Output2Action:(id)sender
{
	if([sender state])
		[K8055Interface setOutputValue:[K8055Interface outputValue]|0x02]; // set the output
	else
		[K8055Interface setOutputValue:[K8055Interface outputValue]&0xFD]; // clear the output
}

//--------------------------------------------------------------------------------------
- (IBAction)Output3Action:(id)sender
{
	if([sender state])
		[K8055Interface setOutputValue:[K8055Interface outputValue]|0x04]; // set the output
	else
		[K8055Interface setOutputValue:[K8055Interface outputValue]&0xFB]; // clear the output
}

//--------------------------------------------------------------------------------------
- (IBAction)Output4Action:(id)sender
{
	if([sender state])
		[K8055Interface setOutputValue:[K8055Interface outputValue]|0x08]; // set the output
	else
		[K8055Interface setOutputValue:[K8055Interface outputValue]&0xF7]; // clear the output
}

//--------------------------------------------------------------------------------------
- (IBAction)Output5Action:(id)sender
{
	if([sender state])
		[K8055Interface setOutputValue:[K8055Interface outputValue]|0x10]; // set the output
	else
		[K8055Interface setOutputValue:[K8055Interface outputValue]&0xEF]; // clear the output
}

//--------------------------------------------------------------------------------------
- (IBAction)Output6Action:(id)sender
{
	if([sender state])
		[K8055Interface setOutputValue:[K8055Interface outputValue]|0x20]; // set the output
	else
		[K8055Interface setOutputValue:[K8055Interface outputValue]&0xDF]; // clear the output
}

//--------------------------------------------------------------------------------------
- (IBAction)Output7Action:(id)sender
{
	if([sender state])
		[K8055Interface setOutputValue:[K8055Interface outputValue]|0x40]; // set the output
	else
		[K8055Interface setOutputValue:[K8055Interface outputValue]&0xBF]; // clear the output
}

//--------------------------------------------------------------------------------------
- (IBAction)Output8Action:(id)sender
{
	if([sender state])
		[K8055Interface setOutputValue:[K8055Interface outputValue]|0x80]; // set the output
	else
		[K8055Interface setOutputValue:[K8055Interface outputValue]&0x7F]; // clear the output
}

//--------------------------------------------------------------------------------------
- (IBAction)OutputTestAction:(id)sender
{
	[K8055Interface setOutputTest:YES];
}

//--------------------------------------------------------------------------------------
- (IBAction)SetAllAnalogAction:(id)sender
{
	[K8055Interface setDA1:0xFF];
	[K8055Interface setDA2:0xFF];
	[DA1Slider setIntValue:0xFF];
	[DA1Text setIntValue:0xFF];
	[DA2Slider setIntValue:0xFF];
	[DA2Text setIntValue:0xFF];

}

//--------------------------------------------------------------------------------------
- (IBAction)SetAllDigitalAction:(id)sender
{
	[K8055Interface setOutputValue:0xFF];
	[Output1 setState:1];
	[Output2 setState:1];
	[Output3 setState:1];
	[Output4 setState:1];
	[Output5 setState:1];
	[Output6 setState:1];
	[Output7 setState:1];
	[Output8 setState:1];
}

@end
