//
//  PRHBarView.m
//  K8055Demo
//
//  Created by Peter Henderson on 11/09/05.
//  Copyright 2005 Control Plus. All rights reserved.
//

#import "PRHBarView.h"


@implementation PRHBarView

//--------------------------------------------------------------
- (id)initWithFrame:(NSRect)frame
{
    self = [super initWithFrame:frame];
    if (self)
	{
		min = 0;
		max = 255;
		value = 0;
		barColor = [[NSColor redColor]retain];
		frameColor = [[NSColor lightGrayColor]retain];
    }
    return self;
}

//--------------------------------------------------------------
- (void)drawRect:(NSRect)rect
{
    // Drawing code here.
	NSRect scaledBounds = [self bounds];
	scaledBounds.size.height = scaledBounds.size.height * value/(max-min);
	NSEraseRect([self bounds]);
	[frameColor set];
	NSFrameRect([self bounds]);
	[barColor set];
	[NSBezierPath fillRect:scaledBounds];
}


//--------------------------------------------------------------
- (float)min
{
    return min;
}

//--------------------------------------------------------------
- (void)setMin:(float)newMin
{
	min = newMin;
	[self setNeedsDisplay:YES];
}

//--------------------------------------------------------------
- (float)max
{
    return max;
}

//--------------------------------------------------------------
- (void)setMax:(float)newMax
{
	max = newMax;
	[self setNeedsDisplay:YES];
}

//--------------------------------------------------------------
- (float)value
{
    return value;
}

//--------------------------------------------------------------
- (void)setValue:(float)newValue
{
	value = newValue;
	[self setNeedsDisplay:YES];
}

//--------------------------------------------------------------
- (NSColor *)barColor
{
    return barColor;
}

//--------------------------------------------------------------
- (void)setBarColor:(NSColor *)newBarColor
{
    if (barColor != newBarColor)
	{
        [barColor release];
        barColor = [newBarColor copy];
		[self setNeedsDisplay:YES];
    }
}

//--------------------------------------------------------------
- (NSColor *)frameColor
{
    return frameColor;
}

//--------------------------------------------------------------
- (void)setFrameColor:(NSColor *)newFrameColor
{
    if (frameColor != newFrameColor)
	{
        [frameColor release];
        frameColor = [newFrameColor copy];
		[self setNeedsDisplay:YES];
    }
}


@end
